//------------------------------------------------------------------ 
#property copyright "www.forex-tsd.com" 
#property link      "www.forex-tsd.com" 
//------------------------------------------------------------------
#property indicator_separate_window 
#property indicator_buffers 8
#property indicator_minimum 0
#property indicator_maximum 100

//
//
//
//
//

extern string RsiTimeFrames = "0;0;0;0;0;0;0";
extern string RsiPeriods    = "5;10;15;20;25;30;40";
extern int    RsiMethod     = 0;
extern int    RsiPrice      = PRICE_CLOSE;
extern string RsiMethods    = "";
extern string _0            = "rsi";
extern string _1            = "Wilders rsi";
extern string _2            = "rsx";
extern string _3            = "Cutler rsi";
extern color  StartColor    = LimeGreen;
extern color  EndColor      = PaleVioletRed;
extern bool   Interpolate   = true;

//
//
//
//
//

double rsi1[];
double rsi2[];
double rsi3[];
double rsi4[];
double rsi5[];
double rsi6[];
double rsi7[];
double rsi8[];
double periods[];
double timeFrames[];

//
//
//
//
//

string indicatorFileName;
int    total;
bool   calculateValue;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void addPeriod(int period)
{
   if (period>0)
   {
      total = ArraySize(periods)+1;
              ArrayResize(periods,total);
                          periods[total-1] = period;
   }
}

//
//
//
//
//

int init() 
{
   SetIndexBuffer(0,rsi1);
   SetIndexBuffer(1,rsi2);
   SetIndexBuffer(2,rsi3);
   SetIndexBuffer(3,rsi4);
   SetIndexBuffer(4,rsi5);
   SetIndexBuffer(5,rsi6);
   SetIndexBuffer(6,rsi7);
   SetIndexBuffer(7,rsi8);
   
      //
      //
      //
      //
      //

      indicatorFileName = WindowExpertName();
      returnBars        = RsiTimeFrames=="returnBars"; if (returnBars) return(0);
      calculateValue    = RsiTimeFrames=="calculateValue";
         if (calculateValue)
         {
            ArrayResize(periods,1); periods[0] = StrToInteger(RsiPeriods); return(0);
         }            

      //
      //
      //
      //
      //
            
      RsiPeriods = StringTrimLeft(StringTrimRight(RsiPeriods));
      if (StringSubstr(RsiPeriods,StringLen(RsiPeriods),1) != ";")
                       RsiPeriods = StringConcatenate(RsiPeriods,";");

         //
         //
         //
         //
         //                                   
            
         int s = 0;
         int i = StringFind(RsiPeriods,";",s);
            while (i > 0)
            {
               addPeriod(StrToInteger(StringSubstr(RsiPeriods,s,i-s)));
               s = i + 1; i = StringFind(RsiPeriods,";",s);
            }
            total = MathMin(total,8);
 
      //
      //
      //
      //
      //
         
      RsiTimeFrames = StringTrimLeft(StringTrimRight(RsiTimeFrames));
      if (StringSubstr(RsiTimeFrames,StringLen(RsiTimeFrames),1) != ";")
                       RsiTimeFrames = StringConcatenate(RsiTimeFrames,";");

         //
         //
         //
         //
         //                                   
         
         ArrayResize(timeFrames,total); ArrayInitialize(timeFrames,0);   
         s = 0;
         i = StringFind(RsiTimeFrames,";",s);
         int current = 0;
            while (i > 0 && current<total)
            {
               int time = stringToTimeFrame(StringSubstr(RsiTimeFrames,s,i-s));
                   timeFrames[current] = time;
                   current += 1; s = i + 1; i = StringFind(RsiTimeFrames,";",s);
                   
            }

      //
      //
      //
      //
      //
            
      string name = "";
         for (i=0; i<total; i++)
         {  
            if (name!="")
                name = name+",";
                name = name+DoubleToStr(periods[i],0);
         }         
      IndicatorShortName("Multi "+getRsiName(RsiMethod)+" ("+name+")"); 
   return(0); 
} 

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start() 
{ 
   static bool initialized = false;
   int j,k,n,counted_bars=IndicatorCounted();
      if (counted_bars < 0) return(-1);
      if (counted_bars > 0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { rsi1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue) { for (int i=limit; i>=0; i--) rsi1[i] = iRsi(iMA(NULL,0,1,0,MODE_SMA,RsiPrice,i),periods[0],i,0,RsiMethod); return(0); }    
   if (!initialized)
   {
      initialized=true;
         for (k = 0; k<total; k++) SetIndexStyle(k,EMPTY,EMPTY,0,gradientColor(k,total,StartColor,EndColor));
   }            

   //
   //
   //
   //
   //
   
   for (k=0; k<total; k++) if (timeFrames[k] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[k],indicatorFileName,"returnBars",0,0)*timeFrames[k]/Period()));
   for (k=0; k<total; k++)
   for (i=limit; i>=0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,RsiPrice,i);
      if (timeFrames[k] == Period()) 
               double rsi = iRsi(price,periods[k],i,k,RsiMethod);
      else 
      {
         int y = iBarShift(NULL,timeFrames[k],Time[i]);
                rsi = iCustom(NULL,timeFrames[k],indicatorFileName,"calculateValue",DoubleToStr(periods[k],0),RsiMethod,RsiPrice,0,y);
      }
            
      //
      //
      //
      //
      //
                               
      switch (k)
      {
         case 0: rsi1[i] = rsi; break;
         case 1: rsi2[i] = rsi; break;
         case 2: rsi3[i] = rsi; break;
         case 3: rsi4[i] = rsi; break;
         case 4: rsi5[i] = rsi; break;
         case 5: rsi6[i] = rsi; break;
         case 6: rsi7[i] = rsi; break;
         case 7: rsi8[i] = rsi; break;
      }
            
      //
      //
      //
      //
      //
            
      if (!Interpolate || timeFrames[k] <= Period() || y==iBarShift(NULL,timeFrames[k],Time[i-1])) continue;

      //
      //
      //
      //
      //

      datetime time = iTime(NULL,timeFrames[k],y);
          for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
          for(j = 1; j < n; j++)
            switch (k)
            {
                case 0 : rsi1[i+j] = rsi1[i] + (rsi1[i+n] - rsi1[i])*j/n; break;
                case 1 : rsi2[i+j] = rsi2[i] + (rsi2[i+n] - rsi2[i])*j/n; break;
                case 2 : rsi3[i+j] = rsi3[i] + (rsi3[i+n] - rsi3[i])*j/n; break;
                case 3 : rsi4[i+j] = rsi4[i] + (rsi4[i+n] - rsi4[i])*j/n; break;
                case 4 : rsi5[i+j] = rsi5[i] + (rsi5[i+n] - rsi5[i])*j/n; break;
                case 5 : rsi6[i+j] = rsi6[i] + (rsi6[i+n] - rsi6[i])*j/n; break;
                case 6 : rsi7[i+j] = rsi7[i] + (rsi7[i+n] - rsi7[i])*j/n; break;
                case 7 : rsi8[i+j] = rsi8[i] + (rsi8[i+n] - rsi8[i])*j/n; break;
            }
   } 
   return(0); 
} 


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string rsiMethodNames[] = {"rsi","Wilders rsi","rsx","Cuttler RSI"};
string getRsiName(int& method)
{
   int max = ArraySize(rsiMethodNames)-1;
      method=MathMax(MathMin(method,max),0); return(rsiMethodNames[method]);
}

//
//
//
//
//

double workRsi[][104];
#define _price  0
#define _change 1
#define _changa 2

double iRsi(double price, double period, int i, int instanceNo=0, int rsiMode=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int z = instanceNo*13; 
      int r = Bars-i-1;
   
   //
   //
   //
   //
   //
   
   workRsi[r][z+_price] = price;
   switch (rsiMode)
   {
      case 0:
         double alpha = 1.0/period; 
         if (r<period)
            {
               int k; double sum = 0; for (k=0; k<period && (r-k-1)>=0; k++) sum += MathAbs(workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price]);
                  workRsi[r][z+_change] = (workRsi[r][z+_price]-workRsi[0][z+_price])/MathMax(k,1);
                  workRsi[r][z+_changa] =                                         sum/MathMax(k,1);
            }
         else
            {
               double change = workRsi[r][z+_price]-workRsi[r-1][z+_price];
                               workRsi[r][z+_change] = workRsi[r-1][z+_change] + alpha*(        change  - workRsi[r-1][z+_change]);
                               workRsi[r][z+_changa] = workRsi[r-1][z+_changa] + alpha*(MathAbs(change) - workRsi[r-1][z+_changa]);
            }
         if (workRsi[r][z+_changa] != 0)
               return(50.0*(workRsi[r][z+_change]/workRsi[r][z+_changa]+1));
         else  return(50.0);
         
      //
      //
      //
      //
      //
      
      case 1 :
         workRsi[r][z+1] = iSmma(0.5*(MathAbs(workRsi[r][z+_price]-workRsi[r-1][z+_price])+(workRsi[r][z+_price]-workRsi[r-1][z+_price])),0.5*(period-1),Bars-i-1,0);
         workRsi[r][z+2] = iSmma(0.5*(MathAbs(workRsi[r][z+_price]-workRsi[r-1][z+_price])-(workRsi[r][z+_price]-workRsi[r-1][z+_price])),0.5*(period-1),Bars-i-1,1);
         if((workRsi[r][z+1] + workRsi[r][z+2]) != 0) 
               return(100.0 * workRsi[r][z+1]/(workRsi[r][z+1] + workRsi[r][z+2]));
         else  return(50);

      //
      //
      //
      //
      //

      case 2 :     
         double Kg = (3.0)/(2.0+period), Hg = 1.0-Kg;
         if (r<period) { for (k=1; k<13; k++) workRsi[r][k+z] = 0; return(50); }  

         //
         //
         //
         //
         //
      
         double mom = workRsi[r][_price+z]-workRsi[r-1][_price+z];
         double moa = MathAbs(mom);
         for (k=0; k<3; k++)
         {
            int kk = k*2;
            workRsi[r][z+kk+1] = Kg*mom                + Hg*workRsi[r-1][z+kk+1];
            workRsi[r][z+kk+2] = Kg*workRsi[r][z+kk+1] + Hg*workRsi[r-1][z+kk+2]; mom = 1.5*workRsi[r][z+kk+1] - 0.5 * workRsi[r][z+kk+2];
            workRsi[r][z+kk+7] = Kg*moa                + Hg*workRsi[r-1][z+kk+7];
            workRsi[r][z+kk+8] = Kg*workRsi[r][z+kk+7] + Hg*workRsi[r-1][z+kk+8]; moa = 1.5*workRsi[r][z+kk+7] - 0.5 * workRsi[r][z+kk+8];
         }
         if (moa != 0)
              return(MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00)); 
         else return(50);
            
      //
      //
      //
      //
      //
      
      case 3 :
         double sump = 0;
         double sumn = 0;
         for (k=0; k<period; k++)
         {
            double diff = workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price];
               if (diff > 0) sump += diff;
               if (diff < 0) sumn -= diff;
         }
         if (sumn > 0)
               return(100.0-100.0/(1.0+sump/sumn));
         else  return(50);
   } 
}

//
//
//
//
//
//

double workSmma[][2];
double iSmma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workSmma,0)!= Bars) ArrayResize(workSmma,Bars);

   //
   //
   //
   //
   //

   if (r<period)
         workSmma[r][instanceNo] = price;
   else  workSmma[r][instanceNo] = workSmma[r-1][instanceNo]+(price-workSmma[r-1][instanceNo])/period;
   return(workSmma[r][instanceNo]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

color gradientColor(int step, int totalSteps, color from, color to)
{
   color newBlue  = getColor(step,totalSteps,(from & 0XFF0000)>>16,(to & 0XFF0000)>>16)<<16;
   color newGreen = getColor(step,totalSteps,(from & 0X00FF00)>> 8,(to & 0X00FF00)>> 8) <<8;
   color newRed   = getColor(step,totalSteps,(from & 0X0000FF)    ,(to & 0X0000FF)    )    ;
   return(newBlue+newGreen+newRed);
}
color getColor(int stepNo, int totalSteps, color from, color to)
{
   double step = (from-to)/(totalSteps-1.0);
   return(MathRound(from-step*stepNo));
}